(* REVISION HEADER  *
 | 
 | $VER: Demo.mod 1.00 (06.09.94) by Stefan Schulz
 | 
 | Module          : Demo
 | Last Modified   : Tuesday, 06.09.94
 | Author          : Stefan Schulz
 | Actual Revision : 1.00
 | 
 | 
 | Description
 | -----------
 |   - Nonfunctional User Interface as Demonstration
 | 
 | Requirements
 | ------------
 |   - triton.library V1.1
 | 
 | Language
 | --------
 |   - M2Amiga Modula 2 Software Development System
 |      Copyright by A+L AG, CH-2540 Grenchen
 | 
 | Revision 1.00  \06.09.94\
 |  - initial revision
 |   
 *  *)

MODULE Demo;

(* IMPORTS ********************************************************************** *)

IMPORT	td	: TritonD,
	tl	: TritonL;

IMPORT	A	: Arts,
	ed	: ExecD,
	id	: IntuitionD,
	S	: SYSTEM,
	ud	: UtilityD;

(* ****************************************************************************** *)

(* --- Objects ------------------------------------------------------------------ *)

VAR	App		: td.TrAppPtr;
	Project		: td.TrProjectPtr;

VAR	AppBuffer	: ARRAY [0..3] OF ud.TagItem;
	ProjectBuffer	: ARRAY [0..15] OF ud.TagItem;


PROCEDURE InitApplication;

 BEGIN
 
 App:= tl.CreateApp
	( S.TAG(AppBuffer,
		td.trcaName,     S.ADR("M2AmigaDemo"),
		td.trcaLongName, S.ADR("M2Amiga Demo Application"),
		td.trcaVersion,  S.ADR("1.0"),
	  ud.tagDone)
	); (* CreateApp *)

 A.Assert(App#NIL, S.ADR("Couldn't create Application!"));
 
 END InitApplication;


PROCEDURE InitProject;

 BEGIN
 
 Project:= tl.OpenProject
	( App,
	  S.TAG(ProjectBuffer,
	  td.trwiID,    10,
	  td.trwiTitle, S.ADR("M2Amiga Demo Application"),
	  
	  td.trwiBackfill, td.trbfFILLBACKGROUND,
	  td.trwiPosition, td.trwpCENTERDISPLAY,
	  td.trgrVert,     td.trgrALIGN,
	    td.trobSpace,    td.trstNORMAL,
	    td.trgrHoriz,    td.trgrPROPSPACES+td.trgrCENTER,
	      td.trobSpace,    td.trstNORMAL,
	      td.trobText,     NIL,
			       td.tratText,  S.ADR("Demo Demo Demo"),
			       td.tratFlags, td.trtx3D,
	      td.trobSpace,    td.trstNORMAL,
	    td.trgrEnd,      NIL,
	    td.trobSpace,    td.trstNORMAL,
	  td.trgrEnd,      NIL,  
	  
	  ud.tagEnd)
	); (* OpenProject *)
 
 A.Assert(Project#NIL, S.ADR("Couldn't open Project!"));
 
 END InitProject;



BEGIN

InitApplication;
InitProject;

IGNORE tl.Wait( App, 0 );

CLOSE

IF	Project # NIL
 THEN	tl.CloseProject(Project);
	Project:= NIL;
 END;

IF	App # NIL
 THEN	tl.DeleteApp(App);
	App:= NIL;
 END;

END Demo.
